/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2008-2010 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/*
 *		^[QbgˑW[iGR-SAKURApj
 *
 *  J[l̃^[Qbgˑ̃CN[ht@CDkernel_impl.h̃^[
 *  Qbgˑ̈ʒutƂȂD
 */

#ifndef TOPPERS_TARGET_CONFIG_H
#define TOPPERS_TARGET_CONFIG_H

/*
 *  ^[QbgVXẽn[hEFA̒`
 */
#include "grsakura.h"


/*
 *  ftHg̔^XNReLXgp̃X^bN̈̒`
 *
 *  X^bNTCYύXꍇ, sectrx.inc_DEFAULT_ISTACK
 *  ẍʒuɂ.blkb߂̃TCY, ȉDEFAULT_ISTKSZ
 *  TCY킹ēlɕύX邱.
 */
#define DEFAULT_ISTKSZ		( 0x800U )
#define DEFAULT_ISTK		(STK_T *)(0x800 - DEFAULT_ISTKSZ)


/*
 *  ^[Qbgˑ̕o͂Ɏgp|[g̒`  
 */
#define TARGET_PUTC_PORTID	( 1 )


#ifndef TOPPERS_MACRO_ONLY

/*
 *  ^[QbgVXeˑ̏
 */
extern void	target_initialize( void );

/*
 *  ^[QbgVXȅI
 *
 *  VXeI鎞ɎgD
 */
extern void	target_exit( void )	NoReturn;

#endif /* TOPPERS_MACRO_ONLY */


/*
 *  vZbTˑW[iRX630pj
 */
#ifdef __RX
#include "rx630_ccrx/rx630_config.h"
#else
#include "rx630_msvc/rx630_config.h"
#endif

/*
 *  g[XOɊւݒ
 */
#define TCNT_TRACE_BUFFER	( 32 )

/*
 *  g[XOo͂ӏ̑I
 *    Oo͂ӏ1Œ`
 *    Oo͂Ȃӏ0Œ`
 */
#ifdef TOPPERS_ENABLE_TRACE
#define LOG_INH_ENTER_ENABLE	( 1 )
#define LOG_INH_LEAVE_ENABLE	( 1 )
#define LOG_EXC_ENTER_ENABLE	( 1 )
#define LOG_EXC_LEAVE_ENABLE	( 1 )
#else
#define LOG_INH_ENTER_ENABLE	( 0 )
#define LOG_INH_LEAVE_ENABLE	( 0 )
#define LOG_EXC_ENTER_ENABLE	( 0 )
#define LOG_EXC_LEAVE_ENABLE	( 0 )
#endif

#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

#endif /* TOPPERS_TARGET_CONFIG_H */
